<?php
/**********************************************************************************
* Bitphp   		                                                                  *
***********************************************************************************
* Bit.ly mod                                                                      *
* SMF Modification                                                                *
* Wrote it by Ohara Mod Team								                      *
* =============================================================================== *
* Software Version:                     1.0.1                                     *
* Support, News, Updates at:	http://missallsunday.com/mods/					  *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it under   *
* the terms of the Creative Commons Attribution-NonCommercial-ShareAlike 3.0      * 
* Unported License.                                                               *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
* See the http://creativecommons.org/licenses/by-nc-sa/3.0/ for details of the    *
* Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.     *
* The latest version of this mod, 												  *
* can always be found at http://missallsunday.com/mods/   					 	  *
**********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

	loadLanguage('Bit');
	
	
	function bit_bbc_add_code(&$codes){
	
		global $modSettings;
		
		// Add the bit.ly bbc only if the master setting is checked
		if(!empty($modSettings['bit_master'])){
				
			$codes[] = array(
				'tag' => 'bit_ly',
				'type' => 'unparsed_content',
				'content' => '<a href="$1" class="bbc_link">$1</a>',
				'validate' => create_function('&$tag, &$data, $disabled', '
					$data = shorten($data);
					$data = strtr($data, array(\'<br />\' => \'\'));
					if (strpos($data, \'http://\') !== 0 && strpos($data, \'https://\') !== 0)
						$data = \'http://\' . $data;
						$data = preg_replace(\'~[\r|\n]+~\', \'\', $data);
				'),
			);

			$codes[] = array(
				'tag' => 'bit_ly',
				'type' => 'unparsed_equals',
				'before' => '<a href="$1" class="bbc_link">',
				'after' => '</a>',
				'validate' => create_function('&$tag, &$data, $disabled', '					
					$data = shorten($data);
					if (substr($data, 0, 1) == \'#\')
						$data = \'#post_\' . substr($data, 1);
					elseif (strpos($data, \'http://\') !== 0 && strpos($data, \'https://\') !== 0)
						$data = \'http://\' . $data;
						$data = preg_replace(\'~[\r|\n]+~\', \'\', $data);
				'),
				'disallow_children' => array('email', 'ftp', 'url', 'iurl'),
				'disabled_after' => ' ($1)',
			);

			// Replace the url tag only if the user really wanna do it...
			if(empty($modSettings['bit_urltag_enable']) || empty($modSettings['bit_master']))
				return;
	
			// Lets replace the existing url tags, many thanks to Arantor for the help ^o^		
			foreach ($codes as $key => $tag){
				if($tag['tag'] == 'url' && $tag['type'] == 'unparsed_content'){

					$codes[$key] = array(
						'tag' => 'url',
						'type' => 'unparsed_content',
						'content' => '<a href="$1" class="bbc_link" target="_blank">$1</a>',
						'validate' => create_function('&$tag, &$data, $disabled', '						
							global $modSettings;						
							if (!empty($modSettings[\'bit_urltag_enable\'])){
								$data = shorten($data);
							}
							$data = strtr($data, array(\'<br />\' => \'\'));
							if (strpos($data, \'http://\') !== 0 && strpos($data, \'https://\') !== 0)
								$data = \'http://\' . $data;
							$data = preg_replace(\'~[\r|\n]+~\', \'\', $data);
						'),
					);
				}

				if($tag['tag'] == 'url' && $tag['type'] == 'unparsed_equals'){
			
					$codes[$key] = array(
						'tag' => 'url',
						'type' => 'unparsed_equals',
						'before' => '<a href="$1" class="bbc_link" target="_blank">',
						'after' => '</a>',
						'validate' => create_function('&$tag, &$data, $disabled', '
							global $modSettings;						
							if (!empty($modSettings[\'bit_urltag_enable\'])){
								$data = shorten($data);
							}
							if (strpos($data, \'http://\') !== 0 && strpos($data, \'https://\') !== 0)
								$data = \'http://\' . $data;
						'),
						'disallow_children' => array('email', 'ftp', 'url', 'iurl'),
						'disabled_after' => ' ($1)',
					);
				}			
			}	 	 
		}
	}
		// The bbc button
	function bit_bbc_add_button($buttons){
	
		global $txt, $modSettings;

		// Add the bit.ly bbc only if the master setting is checked
		if(!empty($modSettings['bit_master'])){
		
			$buttons[count($buttons) - 1][] = array(
				'image' => 'bit_ly',
				'code' => 'bit_ly',
				'before' => '[bit_ly]',
				'after' => '[/bit_ly]',
				'description' => $txt['bit_ly_desc'],
			);
		}
	}	

	// Don't bother on create a whole new page for this, lets use integrate_general_mod_settings ^.^
	function bit_settings(&$config_vars){
	
		global $txt;

		$config_vars[] = array('check', 'bit_master', 'subtext' => $txt['bit_master_sub']);
		$config_vars[] = array('text', 'bit_username', 'subtext' => $txt['bit_username_sub'], 'size' => 26);
		$config_vars[] = array('text', 'bit_key', 'subtext' => $txt['bit_key_sub'], 'size' => 26);
		$config_vars[] = array('check', 'bit_urltag_enable', 'subtext' => $txt['bit_urltag_enable_sub']);
				
	}

	// A simple function to connect to bit.ly API
	function shorten($url) {
			
		global $modSettings, $sourcedir;		
			
		$twt_login = empty($modSettings['bit_username']) ? '' : trim($modSettings['bit_username']);
		$twt_key = empty($modSettings['bit_key']) ? '' : trim($modSettings['bit_key']);
		$temp = 'http://api.bit.ly/v3/shorten?login='.$twt_login.'&apiKey='.$twt_key.'&uri='.$url.'&format=txt';
							
		// Requires a function in a source folder far far away
		require_once($sourcedir .'/Subs-Package.php');

		//Attempts to fetch data from a URL, regardless of PHP's allow_url_fopen setting
		$data = fetch_web_data($temp);
		
		if ($data == null)
			$data = $url;
							
		return $data;
	}

?>